This documentation is automatically generated by online-judge-tools/verification-helper
#define PROBLEM "https://judge.yosupo.jp/problem/aplusb"
#include "my_template.hpp"
#include "random/random_graph.hpp"
#include "graph/count/count_P3_P4_P5.hpp"
void test() {
FOR(N, 20) {
FOR(50) {
Graph<int, 0> G(N);
for (auto& [a, b]: random_graph<false>(N, true)) G.add(a, b);
G.build();
vv(int, adj, N, N);
for (auto& e: G.edges) adj[e.frm][e.to] += 1, adj[e.to][e.frm] += 1;
vi A(N), B(N), C(N);
FOR(a, N) FOR(b, N) FOR(c, N) {
int s = (1 << a) | (1 << b) | (1 << c);
if (popcnt(s) != 3) continue;
A[a] += adj[a][b] * adj[b][c];
}
FOR(a, N) FOR(b, N) FOR(c, N) FOR(d, N) {
int s = (1 << a) | (1 << b) | (1 << c) | (1 << d);
if (popcnt(s) != 4) continue;
B[a] += adj[a][b] * adj[b][c] * adj[c][d];
}
FOR(a, N) FOR(b, N) FOR(c, N) FOR(d, N) FOR(e, N) {
int s = (1 << a) | (1 << b) | (1 << c) | (1 << d) | (1 << e);
if (popcnt(s) != 5) continue;
C[a] += adj[a][b] * adj[b][c] * adj[c][d] * adj[d][e];
}
auto [X, Y, Z] = count_P3_P4_P5_pointwise(G);
assert(A == X);
assert(B == Y);
assert(C == Z);
}
}
}
void solve() {
int a, b;
cin >> a >> b;
cout << a + b << "\n";
}
signed main() {
test();
solve();
return 0;
}
#line 1 "test/1_mytest/count_P3P4P5.test.cpp"
#define PROBLEM "https://judge.yosupo.jp/problem/aplusb"
#line 1 "my_template.hpp"
#if defined(LOCAL)
#include <my_template_compiled.hpp>
#else
// https://codeforces.com/blog/entry/96344
// https://codeforces.com/blog/entry/126772?#comment-1154880
#include <bits/allocator.h>
#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("avx2,popcnt")
#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using u8 = uint8_t;
using u16 = uint16_t;
using u32 = uint32_t;
using u64 = uint64_t;
using i128 = __int128;
using u128 = unsigned __int128;
using f128 = __float128;
template <class T>
constexpr T infty = 0;
template <>
constexpr int infty<int> = 1'010'000'000;
template <>
constexpr ll infty<ll> = 2'020'000'000'000'000'000;
template <>
constexpr u32 infty<u32> = infty<int>;
template <>
constexpr u64 infty<u64> = infty<ll>;
template <>
constexpr i128 infty<i128> = i128(infty<ll>) * 2'000'000'000'000'000'000;
template <>
constexpr double infty<double> = infty<ll>;
template <>
constexpr long double infty<long double> = infty<ll>;
using pi = pair<ll, ll>;
using vi = vector<ll>;
template <class T>
using vc = vector<T>;
template <class T>
using vvc = vector<vc<T>>;
template <class T>
using vvvc = vector<vvc<T>>;
template <class T>
using vvvvc = vector<vvvc<T>>;
template <class T>
using vvvvvc = vector<vvvvc<T>>;
template <class T>
using pq = priority_queue<T>;
template <class T>
using pqg = priority_queue<T, vector<T>, greater<T>>;
#define vv(type, name, h, ...) vector<vector<type>> name(h, vector<type>(__VA_ARGS__))
#define vvv(type, name, h, w, ...) vector<vector<vector<type>>> name(h, vector<vector<type>>(w, vector<type>(__VA_ARGS__)))
#define vvvv(type, name, a, b, c, ...) \
vector<vector<vector<vector<type>>>> name(a, vector<vector<vector<type>>>(b, vector<vector<type>>(c, vector<type>(__VA_ARGS__))))
// https://trap.jp/post/1224/
#define FOR1(a) for (ll _ = 0; _ < ll(a); ++_)
#define FOR2(i, a) for (ll i = 0; i < ll(a); ++i)
#define FOR3(i, a, b) for (ll i = a; i < ll(b); ++i)
#define FOR4(i, a, b, c) for (ll i = a; i < ll(b); i += (c))
#define FOR1_R(a) for (ll i = (a)-1; i >= ll(0); --i)
#define FOR2_R(i, a) for (ll i = (a)-1; i >= ll(0); --i)
#define FOR3_R(i, a, b) for (ll i = (b)-1; i >= ll(a); --i)
#define overload4(a, b, c, d, e, ...) e
#define overload3(a, b, c, d, ...) d
#define FOR(...) overload4(__VA_ARGS__, FOR4, FOR3, FOR2, FOR1)(__VA_ARGS__)
#define FOR_R(...) overload3(__VA_ARGS__, FOR3_R, FOR2_R, FOR1_R)(__VA_ARGS__)
#define all(x) x.begin(), x.end()
#define len(x) ll(x.size())
#define elif else if
#define eb emplace_back
#define mp make_pair
#define mt make_tuple
#define fi first
#define se second
#define stoi stoll
int popcnt(int x) { return __builtin_popcount(x); }
int popcnt(u32 x) { return __builtin_popcount(x); }
int popcnt(ll x) { return __builtin_popcountll(x); }
int popcnt(u64 x) { return __builtin_popcountll(x); }
int popcnt_sgn(int x) { return (__builtin_parity(unsigned(x)) & 1 ? -1 : 1); }
int popcnt_sgn(u32 x) { return (__builtin_parity(x) & 1 ? -1 : 1); }
int popcnt_sgn(ll x) { return (__builtin_parityll(x) & 1 ? -1 : 1); }
int popcnt_sgn(u64 x) { return (__builtin_parityll(x) & 1 ? -1 : 1); }
// (0, 1, 2, 3, 4) -> (-1, 0, 1, 1, 2)
int topbit(int x) { return (x == 0 ? -1 : 31 - __builtin_clz(x)); }
int topbit(u32 x) { return (x == 0 ? -1 : 31 - __builtin_clz(x)); }
int topbit(ll x) { return (x == 0 ? -1 : 63 - __builtin_clzll(x)); }
int topbit(u64 x) { return (x == 0 ? -1 : 63 - __builtin_clzll(x)); }
// (0, 1, 2, 3, 4) -> (-1, 0, 1, 0, 2)
int lowbit(int x) { return (x == 0 ? -1 : __builtin_ctz(x)); }
int lowbit(u32 x) { return (x == 0 ? -1 : __builtin_ctz(x)); }
int lowbit(ll x) { return (x == 0 ? -1 : __builtin_ctzll(x)); }
int lowbit(u64 x) { return (x == 0 ? -1 : __builtin_ctzll(x)); }
template <typename T>
T kth_bit(int k) {
return T(1) << k;
}
template <typename T>
bool has_kth_bit(T x, int k) {
return x >> k & 1;
}
template <typename UINT>
struct all_bit {
struct iter {
UINT s;
iter(UINT s) : s(s) {}
int operator*() const { return lowbit(s); }
iter &operator++() {
s &= s - 1;
return *this;
}
bool operator!=(const iter) const { return s != 0; }
};
UINT s;
all_bit(UINT s) : s(s) {}
iter begin() const { return iter(s); }
iter end() const { return iter(0); }
};
template <typename UINT>
struct all_subset {
static_assert(is_unsigned<UINT>::value);
struct iter {
UINT s, t;
bool ed;
iter(UINT s) : s(s), t(s), ed(0) {}
int operator*() const { return s ^ t; }
iter &operator++() {
(t == 0 ? ed = 1 : t = (t - 1) & s);
return *this;
}
bool operator!=(const iter) const { return !ed; }
};
UINT s;
all_subset(UINT s) : s(s) {}
iter begin() const { return iter(s); }
iter end() const { return iter(0); }
};
template <typename T>
T floor(T a, T b) {
return a / b - (a % b && (a ^ b) < 0);
}
template <typename T>
T ceil(T x, T y) {
return floor(x + y - 1, y);
}
template <typename T>
T bmod(T x, T y) {
return x - y * floor(x, y);
}
template <typename T>
pair<T, T> divmod(T x, T y) {
T q = floor(x, y);
return {q, x - q * y};
}
template <typename T, typename U>
T SUM(const vector<U> &A) {
T sm = 0;
for (auto &&a: A) sm += a;
return sm;
}
#define MIN(v) *min_element(all(v))
#define MAX(v) *max_element(all(v))
#define LB(c, x) distance((c).begin(), lower_bound(all(c), (x)))
#define UB(c, x) distance((c).begin(), upper_bound(all(c), (x)))
#define UNIQUE(x) sort(all(x)), x.erase(unique(all(x)), x.end()), x.shrink_to_fit()
template <typename T>
T POP(deque<T> &que) {
T a = que.front();
que.pop_front();
return a;
}
template <typename T>
T POP(pq<T> &que) {
T a = que.top();
que.pop();
return a;
}
template <typename T>
T POP(pqg<T> &que) {
T a = que.top();
que.pop();
return a;
}
template <typename T>
T POP(vc<T> &que) {
T a = que.back();
que.pop_back();
return a;
}
template <typename F>
ll binary_search(F check, ll ok, ll ng, bool check_ok = true) {
if (check_ok) assert(check(ok));
while (abs(ok - ng) > 1) {
auto x = (ng + ok) / 2;
(check(x) ? ok : ng) = x;
}
return ok;
}
template <typename F>
double binary_search_real(F check, double ok, double ng, int iter = 100) {
FOR(iter) {
double x = (ok + ng) / 2;
(check(x) ? ok : ng) = x;
}
return (ok + ng) / 2;
}
template <class T, class S>
inline bool chmax(T &a, const S &b) {
return (a < b ? a = b, 1 : 0);
}
template <class T, class S>
inline bool chmin(T &a, const S &b) {
return (a > b ? a = b, 1 : 0);
}
// ? は -1
vc<int> s_to_vi(const string &S, char first_char) {
vc<int> A(S.size());
FOR(i, S.size()) { A[i] = (S[i] != '?' ? S[i] - first_char : -1); }
return A;
}
template <typename T, typename U>
vector<T> cumsum(vector<U> &A, int off = 1) {
int N = A.size();
vector<T> B(N + 1);
FOR(i, N) { B[i + 1] = B[i] + A[i]; }
if (off == 0) B.erase(B.begin());
return B;
}
// stable sort
template <typename T>
vector<int> argsort(const vector<T> &A) {
vector<int> ids(len(A));
iota(all(ids), 0);
sort(all(ids), [&](int i, int j) { return (A[i] == A[j] ? i < j : A[i] < A[j]); });
return ids;
}
// A[I[0]], A[I[1]], ...
template <typename T>
vc<T> rearrange(const vc<T> &A, const vc<int> &I) {
vc<T> B(len(I));
FOR(i, len(I)) B[i] = A[I[i]];
return B;
}
template <typename T, typename... Vectors>
void concat(vc<T> &first, const Vectors &... others) {
vc<T> &res = first;
(res.insert(res.end(), others.begin(), others.end()), ...);
}
#endif
#line 3 "test/1_mytest/count_P3P4P5.test.cpp"
#line 2 "ds/hashmap.hpp"
// u64 -> Val
template <typename Val>
struct HashMap {
// n は入れたいものの個数で ok
HashMap(u32 n = 0) { build(n); }
void build(u32 n) {
u32 k = 8;
while (k < n * 2) k *= 2;
cap = k / 2, mask = k - 1;
key.resize(k), val.resize(k), used.assign(k, 0);
}
// size を保ったまま. size=0 にするときは build すること.
void clear() {
used.assign(len(used), 0);
cap = (mask + 1) / 2;
}
int size() { return len(used) / 2 - cap; }
int index(const u64& k) {
int i = 0;
for (i = hash(k); used[i] && key[i] != k; i = (i + 1) & mask) {}
return i;
}
Val& operator[](const u64& k) {
if (cap == 0) extend();
int i = index(k);
if (!used[i]) { used[i] = 1, key[i] = k, val[i] = Val{}, --cap; }
return val[i];
}
Val get(const u64& k, Val default_value) {
int i = index(k);
return (used[i] ? val[i] : default_value);
}
bool count(const u64& k) {
int i = index(k);
return used[i] && key[i] == k;
}
// f(key, val)
template <typename F>
void enumerate_all(F f) {
FOR(i, len(used)) if (used[i]) f(key[i], val[i]);
}
private:
u32 cap, mask;
vc<u64> key;
vc<Val> val;
vc<bool> used;
u64 hash(u64 x) {
static const u64 FIXED_RANDOM = std::chrono::steady_clock::now().time_since_epoch().count();
x += FIXED_RANDOM;
x = (x ^ (x >> 30)) * 0xbf58476d1ce4e5b9;
x = (x ^ (x >> 27)) * 0x94d049bb133111eb;
return (x ^ (x >> 31)) & mask;
}
void extend() {
vc<pair<u64, Val>> dat;
dat.reserve(len(used) / 2 - cap);
FOR(i, len(used)) {
if (used[i]) dat.eb(key[i], val[i]);
}
build(2 * len(dat));
for (auto& [a, b]: dat) (*this)[a] = b;
}
};
#line 3 "graph/base.hpp"
template <typename T>
struct Edge {
int frm, to;
T cost;
int id;
};
template <typename T = int, bool directed = false>
struct Graph {
static constexpr bool is_directed = directed;
int N, M;
using cost_type = T;
using edge_type = Edge<T>;
vector<edge_type> edges;
vector<int> indptr;
vector<edge_type> csr_edges;
vc<int> vc_deg, vc_indeg, vc_outdeg;
bool prepared;
class OutgoingEdges {
public:
OutgoingEdges(const Graph* G, int l, int r) : G(G), l(l), r(r) {}
const edge_type* begin() const {
if (l == r) { return 0; }
return &G->csr_edges[l];
}
const edge_type* end() const {
if (l == r) { return 0; }
return &G->csr_edges[r];
}
private:
const Graph* G;
int l, r;
};
bool is_prepared() { return prepared; }
Graph() : N(0), M(0), prepared(0) {}
Graph(int N) : N(N), M(0), prepared(0) {}
void build(int n) {
N = n, M = 0;
prepared = 0;
edges.clear();
indptr.clear();
csr_edges.clear();
vc_deg.clear();
vc_indeg.clear();
vc_outdeg.clear();
}
void add(int frm, int to, T cost = 1, int i = -1) {
assert(!prepared);
assert(0 <= frm && 0 <= to && to < N);
if (i == -1) i = M;
auto e = edge_type({frm, to, cost, i});
edges.eb(e);
++M;
}
#ifdef FASTIO
// wt, off
void read_tree(bool wt = false, int off = 1) { read_graph(N - 1, wt, off); }
void read_graph(int M, bool wt = false, int off = 1) {
for (int m = 0; m < M; ++m) {
INT(a, b);
a -= off, b -= off;
if (!wt) {
add(a, b);
} else {
T c;
read(c);
add(a, b, c);
}
}
build();
}
#endif
void build() {
assert(!prepared);
prepared = true;
indptr.assign(N + 1, 0);
for (auto&& e: edges) {
indptr[e.frm + 1]++;
if (!directed) indptr[e.to + 1]++;
}
for (int v = 0; v < N; ++v) { indptr[v + 1] += indptr[v]; }
auto counter = indptr;
csr_edges.resize(indptr.back() + 1);
for (auto&& e: edges) {
csr_edges[counter[e.frm]++] = e;
if (!directed) csr_edges[counter[e.to]++] = edge_type({e.to, e.frm, e.cost, e.id});
}
}
OutgoingEdges operator[](int v) const {
assert(prepared);
return {this, indptr[v], indptr[v + 1]};
}
vc<int> deg_array() {
if (vc_deg.empty()) calc_deg();
return vc_deg;
}
pair<vc<int>, vc<int>> deg_array_inout() {
if (vc_indeg.empty()) calc_deg_inout();
return {vc_indeg, vc_outdeg};
}
int deg(int v) {
if (vc_deg.empty()) calc_deg();
return vc_deg[v];
}
int in_deg(int v) {
if (vc_indeg.empty()) calc_deg_inout();
return vc_indeg[v];
}
int out_deg(int v) {
if (vc_outdeg.empty()) calc_deg_inout();
return vc_outdeg[v];
}
#ifdef FASTIO
void debug() {
print("Graph");
if (!prepared) {
print("frm to cost id");
for (auto&& e: edges) print(e.frm, e.to, e.cost, e.id);
} else {
print("indptr", indptr);
print("frm to cost id");
FOR(v, N) for (auto&& e: (*this)[v]) print(e.frm, e.to, e.cost, e.id);
}
}
#endif
vc<int> new_idx;
vc<bool> used_e;
// G における頂点 V[i] が、新しいグラフで i になるようにする
// {G, es}
// sum(deg(v)) の計算量になっていて、
// 新しいグラフの n+m より大きい可能性があるので注意
Graph<T, directed> rearrange(vc<int> V, bool keep_eid = 0) {
if (len(new_idx) != N) new_idx.assign(N, -1);
int n = len(V);
FOR(i, n) new_idx[V[i]] = i;
Graph<T, directed> G(n);
vc<int> history;
FOR(i, n) {
for (auto&& e: (*this)[V[i]]) {
if (len(used_e) <= e.id) used_e.resize(e.id + 1);
if (used_e[e.id]) continue;
int a = e.frm, b = e.to;
if (new_idx[a] != -1 && new_idx[b] != -1) {
history.eb(e.id);
used_e[e.id] = 1;
int eid = (keep_eid ? e.id : -1);
G.add(new_idx[a], new_idx[b], e.cost, eid);
}
}
}
FOR(i, n) new_idx[V[i]] = -1;
for (auto&& eid: history) used_e[eid] = 0;
G.build();
return G;
}
Graph<T, true> to_directed_tree(int root = -1) {
if (root == -1) root = 0;
assert(!is_directed && prepared && M == N - 1);
Graph<T, true> G1(N);
vc<int> par(N, -1);
auto dfs = [&](auto& dfs, int v) -> void {
for (auto& e: (*this)[v]) {
if (e.to == par[v]) continue;
par[e.to] = v, dfs(dfs, e.to);
}
};
dfs(dfs, root);
for (auto& e: edges) {
int a = e.frm, b = e.to;
if (par[a] == b) swap(a, b);
assert(par[b] == a);
G1.add(a, b, e.cost);
}
G1.build();
return G1;
}
HashMap<int> MP_FOR_EID;
int get_eid(u64 a, u64 b) {
if (len(MP_FOR_EID) == 0) {
MP_FOR_EID.build(N - 1);
for (auto& e: edges) {
u64 a = e.frm, b = e.to;
u64 k = to_eid_key(a, b);
MP_FOR_EID[k] = e.id;
}
}
return MP_FOR_EID.get(to_eid_key(a, b), -1);
}
u64 to_eid_key(u64 a, u64 b) {
if (!directed && a > b) swap(a, b);
return N * a + b;
}
private:
void calc_deg() {
assert(vc_deg.empty());
vc_deg.resize(N);
for (auto&& e: edges) vc_deg[e.frm]++, vc_deg[e.to]++;
}
void calc_deg_inout() {
assert(vc_indeg.empty());
vc_indeg.resize(N);
vc_outdeg.resize(N);
for (auto&& e: edges) { vc_indeg[e.to]++, vc_outdeg[e.frm]++; }
}
};
#line 2 "random/base.hpp"
u64 RNG_64() {
static u64 x_ = u64(chrono::duration_cast<chrono::nanoseconds>(chrono::high_resolution_clock::now().time_since_epoch()).count()) * 10150724397891781847ULL;
x_ ^= x_ << 7;
return x_ ^= x_ >> 9;
}
u64 RNG(u64 lim) { return RNG_64() % lim; }
ll RNG(ll l, ll r) { return l + RNG_64() % (r - l); }
#line 2 "random/shuffle.hpp"
template <typename T>
void shuffle(vc<T>& A) {
FOR(i, len(A)) {
int j = RNG(0, i + 1);
if (i != j) swap(A[i], A[j]);
}
}
#line 2 "ds/unionfind/unionfind.hpp"
struct UnionFind {
int n, n_comp;
vc<int> dat; // par or (-size)
UnionFind(int n = 0) { build(n); }
void build(int m) {
n = m, n_comp = m;
dat.assign(n, -1);
}
void reset() { build(n); }
int operator[](int x) {
while (dat[x] >= 0) {
int pp = dat[dat[x]];
if (pp < 0) { return dat[x]; }
x = dat[x] = pp;
}
return x;
}
ll size(int x) {
x = (*this)[x];
return -dat[x];
}
bool merge(int x, int y) {
x = (*this)[x], y = (*this)[y];
if (x == y) return false;
if (-dat[x] < -dat[y]) swap(x, y);
dat[x] += dat[y], dat[y] = x, n_comp--;
return true;
}
vc<int> get_all() {
vc<int> A(n);
FOR(i, n) A[i] = (*this)[i];
return A;
}
};
#line 5 "random/random_graph.hpp"
void random_relabel(int N, vc<pair<int, int>>& G) {
shuffle(G);
vc<int> A(N);
FOR(i, N) A[i] = i;
shuffle(A);
for (auto& [a, b]: G) a = A[a], b = A[b];
}
template <int DIRECTED>
vc<pair<int, int>> random_graph(int n, bool simple) {
vc<pair<int, int>> G, cand;
FOR(a, n) FOR(b, n) {
if (simple && a == b) continue;
if (!DIRECTED && a > b) continue;
cand.eb(a, b);
}
int m = RNG(0, len(cand) + 1);
set<int> ss;
FOR(m) {
while (1) {
int i = RNG(0, len(cand));
if (simple && ss.count(i)) continue;
ss.insert(i);
auto [a, b] = cand[i];
G.eb(a, b);
break;
}
}
random_relabel(n, G);
return G;
}
vc<pair<int, int>> random_tree(int n) {
vc<pair<int, int>> G;
FOR(i, 1, n) { G.eb(RNG(0, i), i); }
random_relabel(n, G);
return G;
}
// EDGE = true: 各辺が唯一のサイクル(関節点でサイクルまたは辺)
// EDGE = false: 各頂点が唯一のサイクル(橋でサイクルまたは辺)
vc<pair<int, int>> random_cactus(int N, bool EDGE) {
if (!EDGE) {
// n 頂点を 1 または 3 以上に分割
vvc<int> A;
int n = RNG(1, N + 1);
vc<int> S(n, 1);
int rest = N - n;
while (rest > 0) {
int k = RNG(0, n);
if (S[k] == 1) {
if (rest == 1) {
S.eb(1), rest = 0;
} else {
S[k] += 2, rest -= 2;
}
} else {
S[k]++, rest--;
}
}
n = len(S);
int p = 0;
FOR(i, n) {
vc<int> C;
FOR(v, p, p + S[i]) C.eb(v);
A.eb(C);
p += S[i];
}
int m = len(A);
auto H = random_tree(m);
vc<pair<int, int>> G;
FOR(i, m) {
vc<int>& V = A[i];
if (len(V) == 1) continue;
FOR(k, len(V)) { G.eb(V[k], V[(1 + k) % len(V)]); }
}
for (auto& [c1, c2]: H) {
int a = A[c1][RNG(0, len(A[c1]))];
int b = A[c2][RNG(0, len(A[c2]))];
G.eb(a, b);
}
random_relabel(N, G);
return G;
}
assert(EDGE);
if (N == 1) return {};
int n = RNG(1, N);
vc<int> S(n, 2);
int rest = N - 1 - n;
while (rest > 0) {
int k = RNG(0, n);
S[k]++, --rest;
}
vvc<int> A;
int p = 0;
FOR(i, n) {
vc<int> C;
FOR(v, p, p + S[i]) C.eb(v);
A.eb(C);
p += S[i];
}
assert(p == N + n - 1);
UnionFind uf(p);
auto H = random_tree(n);
for (auto& [c1, c2]: H) {
int a = A[c1][RNG(0, len(A[c1]))];
int b = A[c2][RNG(0, len(A[c2]))];
uf.merge(a, b);
}
vc<int> new_idx(p);
int x = 0;
FOR(i, p) if (uf[i] == i) new_idx[i] = x++;
assert(x == N);
FOR(i, p) new_idx[i] = new_idx[uf[i]];
vc<pair<int, int>> G;
FOR(i, n) {
vc<int>& V = A[i];
for (auto& v: V) v = new_idx[v];
if (len(V) == 2) {
G.eb(V[0], V[1]);
} else {
FOR(k, len(V)) { G.eb(V[k], V[(1 + k) % len(V)]); }
}
}
random_relabel(N, G);
return G;
}
// |child| = 0 or 2 or (1 if can1), ラベルはトポロジカル
// return: par
vc<int> random_binary_tree(int N, bool can_1) {
if (can_1) {
vc<int> S;
S.eb(0), S.eb(0);
vc<int> par(N, -1);
FOR(v, 1, N) {
int k = RNG(0, len(S));
swap(S[k], S.back());
par[v] = POP(S);
S.eb(v), S.eb(v);
}
return par;
}
// 0 or 2
assert(N % 2 == 1);
vc<int> par(N, -1);
vc<int> S;
FOR(v, N / 2, N) S.eb(v);
int nxt = N / 2 - 1;
while (len(S) >= 2) {
shuffle(S);
int a = POP(S), b = POP(S);
par[a] = par[b] = nxt;
S.eb(nxt), --nxt;
}
return par;
}
#line 2 "graph/count/count_C3_C4.hpp"
// 各点に対してその点を含む C3, C4 を数える
// simple graph を仮定
template <typename GT>
pair<vi, vi> count_C3_C4_pointwise(GT &G) {
static_assert(!GT::is_directed);
int N = G.N;
auto deg = G.deg_array();
auto I = argsort(deg);
reverse(all(I));
vc<int> rk(N);
FOR(i, N) rk[I[i]] = i;
// 遷移先を降順に並べる
vvc<int> TO(N);
for (auto &&e: G.edges) {
int a = rk[e.frm], b = rk[e.to];
TO[a].eb(b), TO[b].eb(a);
}
FOR(v, N) { sort(all(TO[v])), reverse(all(TO[v])); }
vc<int> A(N);
vi C3(N), C4(N);
FOR(a, N) {
for (auto &b: TO[a]) TO[b].pop_back();
for (auto &b: TO[a]) {
for (auto &c: TO[b]) { C4[a] += A[c], C4[c] += A[c], A[c] += 1; }
}
for (auto &b: TO[a]) {
C3[a] += A[b], C3[b] += A[b] + A[b];
for (auto &c: TO[b]) { C4[b] += A[c] - 1; }
}
for (auto &b: TO[a]) {
for (auto &c: TO[b]) { A[c] = 0; }
}
}
for (auto &x: C3) x /= 2;
C3 = rearrange(C3, rk), C4 = rearrange(C4, rk);
return {C3, C4};
}
// (2e5,5e5) で 500 ms
// https://codeforces.com/gym/104053/problem/K
template <typename GT>
pair<ll, ll> count_C3_C4(GT &G) {
static_assert(!GT::is_directed);
int N = G.N;
ll x3 = 0, x4 = 0;
auto deg = G.deg_array();
auto I = argsort(deg);
reverse(all(I));
vc<int> rk(N);
FOR(i, N) rk[I[i]] = i;
// 遷移先を降順に並べる
vvc<int> TO(N);
for (auto &&e: G.edges) {
int a = rk[e.frm], b = rk[e.to];
if (a != b) TO[a].eb(b), TO[b].eb(a);
}
FOR(v, N) {
sort(all(TO[v]));
reverse(all(TO[v]));
}
vc<int> A(N);
FOR(a, N) {
for (auto &&b: TO[a]) TO[b].pop_back();
for (auto &&b: TO[a]) {
for (auto &&c: TO[b]) { x4 += A[c]++; }
}
for (auto &&b: TO[a]) { x3 += A[b]; }
for (auto &&b: TO[a]) {
for (auto &&c: TO[b]) { A[c] = 0; }
}
}
x3 /= 2;
return {x3, x4};
}
#line 2 "graph/count/count_P3_P4_P5.hpp"
// 各 v に対して、v を始点とする P4, P5, P5 を数える(頂点数 3, 4, 5)
// simple graph を仮定している
template <typename GT>
tuple<vi, vi, vi> count_P3_P4_P5_pointwise(GT& G) {
static_assert(!GT::is_directed);
int N = G.N;
auto deg = G.deg_array();
auto [C3, C4] = count_C3_C4_pointwise(G);
vi P3(N), P4(N), P5(N);
FOR(v, N) {
for (auto&& e: G[v]) {
if (e.frm == e.to) continue;
P3[v] += deg[e.to] - 1;
}
}
FOR(v, N) {
for (auto&& e: G[v]) {
if (e.frm == e.to) continue;
P4[v] += P3[e.to] - (deg[v] - 1);
}
P4[v] -= C3[v] * 2;
}
FOR(v, N) {
for (auto&& e: G[v]) {
if (e.frm == e.to) continue;
P5[v] += P4[e.to];
}
P5[v] -= C4[v] * 2;
P5[v] -= C3[v] * 2 * (deg[v] - 3);
P5[v] -= P3[v] * (deg[v] - 1);
}
return {P3, P4, P5};
}
#line 6 "test/1_mytest/count_P3P4P5.test.cpp"
void test() {
FOR(N, 20) {
FOR(50) {
Graph<int, 0> G(N);
for (auto& [a, b]: random_graph<false>(N, true)) G.add(a, b);
G.build();
vv(int, adj, N, N);
for (auto& e: G.edges) adj[e.frm][e.to] += 1, adj[e.to][e.frm] += 1;
vi A(N), B(N), C(N);
FOR(a, N) FOR(b, N) FOR(c, N) {
int s = (1 << a) | (1 << b) | (1 << c);
if (popcnt(s) != 3) continue;
A[a] += adj[a][b] * adj[b][c];
}
FOR(a, N) FOR(b, N) FOR(c, N) FOR(d, N) {
int s = (1 << a) | (1 << b) | (1 << c) | (1 << d);
if (popcnt(s) != 4) continue;
B[a] += adj[a][b] * adj[b][c] * adj[c][d];
}
FOR(a, N) FOR(b, N) FOR(c, N) FOR(d, N) FOR(e, N) {
int s = (1 << a) | (1 << b) | (1 << c) | (1 << d) | (1 << e);
if (popcnt(s) != 5) continue;
C[a] += adj[a][b] * adj[b][c] * adj[c][d] * adj[d][e];
}
auto [X, Y, Z] = count_P3_P4_P5_pointwise(G);
assert(A == X);
assert(B == Y);
assert(C == Z);
}
}
}
void solve() {
int a, b;
cin >> a >> b;
cout << a + b << "\n";
}
signed main() {
test();
solve();
return 0;
}